package betterwithmods.common.blocks.mechanical;

import betterwithmods.common.BWMItems;
import betterwithmods.common.blocks.tile.gen.IColor;
import betterwithmods.common.blocks.tile.gen.TileEntityWindmillHorizontal;
import betterwithmods.common.blocks.tile.gen.TileEntityWindmillVertical;
import betterwithmods.util.ColorUtils;
import betterwithmods.util.DirUtils;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class BlockWindmill extends BlockAxleGenerator {
    public BlockWindmill() {
        super(Material.field_151575_d);
    }

    @Override
    public ItemStack func_185473_a(World world, BlockPos pos, IBlockState state) {
        return new ItemStack(BWMItems.AXLE_GENERATOR, 1, state.func_177229_b(DirUtils.AXIS) == EnumFacing.Axis.Y ? 2 : 0);
    }

    @Override
    public void func_176213_c(World world, BlockPos pos, IBlockState state) {
        super.func_176213_c(world, pos, state);
        //TODO
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        ItemStack stack = player.func_184586_b(hand);
        TileEntity tile = world.func_175625_s(pos);

        if (world.field_72995_K && !stack.func_190926_b() && ColorUtils.contains(stack.func_77973_b(), stack.func_77952_i()))
            return true;

        if (!world.field_72995_K && tile != null && tile instanceof IColor && !stack.func_190926_b() && ColorUtils.contains(stack.func_77973_b(), stack.func_77952_i())) {
            IColor color = (IColor) tile;
            int meta = ColorUtils.get(stack.func_77973_b(), stack.func_77952_i()); //reverseMeta[stack.getItemDamage()];
            if (color.dyeBlade(meta)) {
                if (!player.field_71075_bZ.field_75098_d)
                    stack.func_190918_g(1);
                return true;
            }
        }
        return false;
    }

    @Override
    public boolean hasTileEntity(IBlockState state) {
        return true;
    }

    @Override
    public TileEntity createTileEntity(World world, IBlockState state) {
        if (state.func_177229_b(DirUtils.AXIS) == EnumFacing.Axis.Y)
            return new TileEntityWindmillVertical();
        else
            return new TileEntityWindmillHorizontal();
    }
}
